#include <alloc.h>
#include <conio.h>
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include "defines.h"    /* global defines                   */
#include "error_fn.h"   /* function prototypes, error enums */
#include "field.h"      /* for disp_message()               */

void error_fn(int errnum, char *msg)
{
    char str[80];

    unsigned long freemem;

    freemem=farcoreleft();

    switch(errnum) {    /* non-fatal errors */
        case EFOPEN:
            sprintf(str,"Cannot open data file %s for output.  <ENTER> to continue:",msg);
            disp_message(str);
            getch();
            return;
        case EFCLOSE:
            sprintf(str,"Error writing %s.  <ENTER> to continue",msg);
            disp_message(str);
            getch();
            return;
    }

    /* fatal errors -- time to bail back to DOS */
    closegraph();
    switch(errnum) {
        case EGRAPH:
            fprintf(stderr,"Graphics error: %s\n",msg);
            break;
        case EMEM:
            fprintf(stderr,"Not enough memmory in procdeure '%s'.\n",msg);
            fprintf(stderr,"farcoreleft()=%lu\n",freemem);
            fprintf(stderr,"Try running Lissajous with more free memmory.\n");
            break;
        case EUNK:
        default:
            fprintf(stderr,"Unknown error in procedure '%s'.\n",msg);
            fprintf(stderr,"Please contact Aaron Caba\n");
            break;
    }

    fprintf(stderr,"Error number:  %i\n",errnum);
    fprintf(stderr,"Press any key to halt:");
    getch();
    exit(errnum);
}
